package jx.cn.escort.apps

import android.app.Application
import android.util.Log
import androidx.lifecycle.Lifecycle
import androidx.lifecycle.LifecycleOwner
import androidx.lifecycle.LifecycleRegistry
import com.xuexiang.xui.XUI
import org.koin.android.ext.koin.androidContext
import org.koin.core.context.startKoin
import org.koin.core.logger.Level
import org.koin.core.logger.Logger
import org.koin.core.logger.MESSAGE

/**
 *  <p>Application的子类用来监听App整个生命周期</>
 */
internal class InternalApp: Application(), LifecycleOwner{


    private val mRegistry: LifecycleRegistry = LifecycleRegistry(this)



    override val lifecycle: Lifecycle
        get() = mRegistry

    /**
     *  <p>应用创建事件</>
     */
    override fun onCreate() {
        super.onCreate()
        startKoin {
            logger(object :Logger(level = Level.DEBUG){
                override fun display(level: Level, msg: MESSAGE) {
                    Log.d("koin",msg)
                }

            })
            androidContext(androidContext = this@InternalApp)
            modules()
        }
    }


}