package jx.cn.escort.ui.activity



import android.annotation.SuppressLint
import android.content.Context
import android.content.SharedPreferences
import com.xuexiang.xui.widget.activity.BaseSplashActivity
import jx.cn.escort.R
import jx.cn.escort.databinding.ActivityLaunchBinding
import jx.cn.escort.databinding.ActivityMainBinding
import jx.cn.escort.extension.ExtensionBinding.Companion.binding
import jx.cn.escort.utils.ActivityUtils
import org.koin.core.component.KoinComponent
import org.koin.core.component.inject


@SuppressLint("CustomSplashScreen")
class LaunchActivity: BaseSplashActivity(), KoinComponent {

    private val mBinding: ActivityLaunchBinding by binding<ActivityLaunchBinding>()
    private val mContext: Context   by  inject()


    private val defaultSharedPreferences: SharedPreferences = androidx.preference.PreferenceManager.getDefaultSharedPreferences(mContext)

    override fun getSplashDurationMillis(): Long {
        return 500
    }

    override fun onCreateActivity() {
        initSplashView(mBinding.root.id);
        startSplash(true);
    }

    override fun onSplashFinished() {
        if(defaultSharedPreferences.contains("isAuth")){
            ActivityUtils.startActivity(this, MainActivity::class.java)
            finish()
        }else{
            ActivityUtils.startActivity(this, LoginActivity::class.java)
            finish()
        }

    }


}