package jx.cn.escort.ui.activity



import android.content.Context
import android.content.DialogInterface
import android.content.DialogInterface.OnShowListener
import android.content.SharedPreferences
import android.graphics.Color
import android.os.Bundle
import android.view.View
import android.widget.CompoundButton
import androidx.appcompat.app.AppCompatActivity
import androidx.lifecycle.lifecycleScope
import androidx.viewpager.widget.ViewPager
import com.google.android.material.radiobutton.MaterialRadioButton
import com.xuexiang.xui.XUI
import com.xuexiang.xui.utils.WidgetUtils
import com.xuexiang.xui.widget.dialog.materialdialog.GravityEnum
import com.xuexiang.xui.widget.dialog.materialdialog.MaterialDialog
import com.xuexiang.xui.widget.tabbar.TabSegment
import jx.cn.escort.R
import jx.cn.escort.databinding.ActivitySysSettingBinding
import jx.cn.escort.extension.ExtensionBinding.Companion.binding
import jx.cn.escort.utils.ActivityUtils
import kotlinx.coroutines.delay
import kotlinx.coroutines.launch
import org.koin.core.component.KoinComponent
import org.koin.core.component.inject


class SysSettingActivity : AppCompatActivity(), KoinComponent {

    private val mBinding: ActivitySysSettingBinding by binding<ActivitySysSettingBinding>()

    private val mContext: Context by  inject()

    private val defaultSharedPreferences: SharedPreferences = androidx.preference.PreferenceManager.getDefaultSharedPreferences(mContext)



    override fun onCreate(savedInstanceState: Bundle?) {
        XUI.initTheme(this@SysSettingActivity);
        super.onCreate(savedInstanceState)
        setContentView(mBinding.root)
        val tabSegmentTitle = mBinding.tabSegmentTitle
        tabSegmentTitle.setTitle("系统设置")
        tabSegmentTitle.setLeftClickListener(object:View.OnClickListener{
            override fun onClick(v: View?) {
                ActivityUtils.startActivity(this@SysSettingActivity,MainActivity::class.java)
            }
        })

        var ckColor=Color.parseColor("#8ad1d2")
        var unCkColor=Color.BLACK
        val tabSegment = mBinding.tabSegment
        val doc = TabSegment.Tab("基本资料")
        doc.setTextColor(unCkColor,ckColor)


        val doc1 = TabSegment.Tab("修改密码")
        doc1.setTextColor(unCkColor,ckColor)

        tabSegment.addTab(  doc)
        tabSegment.addTab(  doc1)
        tabSegment.setupWithViewPager(ViewPager(this@SysSettingActivity), false);
        tabSegment.setMode(TabSegment.MODE_FIXED);
        tabSegment.notifyDataChanged();
        tabSegment.addOnTabSelectedListener(object :TabSegment.OnTabSelectedListener{

            override fun onTabSelected(index: Int) {
                val setsCommonSave = mBinding.setsCommonSave
                val setsCommonCancel = mBinding.setsCommonCancel

              if(index != 1){
                  val setsUserInfo = mBinding.setsUserInfo
                  setsUserInfo.visibility= View.VISIBLE

                  val setUserPass = mBinding.setsUserPass
                  setUserPass.visibility= View.GONE


                  val setSexMale = setsUserInfo.findViewById<MaterialRadioButton>(jx.cn.escort.R.id.sets_sex_male)
                  val setSexFeMale = setsUserInfo.findViewById<MaterialRadioButton>(jx.cn.escort.R.id.sets_sex_female)
                  setSexMale.setOnCheckedChangeListener(object : CompoundButton.OnCheckedChangeListener{
                      override fun onCheckedChanged(buttonView: CompoundButton?, isChecked: Boolean) {
                         if(isChecked){
                             setSexFeMale.isChecked=false
                         }
                      }
                  })

                  setSexFeMale.setOnCheckedChangeListener(object : CompoundButton.OnCheckedChangeListener{
                      override fun onCheckedChanged(buttonView: CompoundButton?, isChecked: Boolean) {
                          if(isChecked){
                              setSexMale.isChecked=false
                          }
                      }
                  })





              }else{
                  val setsUserInfo = mBinding.setsUserInfo
                  setsUserInfo.visibility= View.GONE

                  val setUserPass = mBinding.setsUserPass
                  setUserPass.visibility= View.VISIBLE
              }


                setsCommonSave.setOnClickListener(object:View.OnClickListener{
                    override fun onClick(v: View?) {
                            lifecycleScope.launch {
                                MaterialDialog.Builder(this@SysSettingActivity)
                                    .content("保存中...")
                                    .contentGravity(GravityEnum.CENTER)
                                    .progress(false, 150, true)
                                    .showListener(OnShowListener {
                                        dialog: DialogInterface? ->
                                        run {
                                            var materialDialog = dialog as MaterialDialog
                                            while (materialDialog.currentProgress != materialDialog.maxProgress) {
                                                materialDialog.incrementProgress(10);
                                            }
                                            if(materialDialog.currentProgress ==materialDialog.maxProgress){

                                                }

                                        }

                                    }).show()
                            }
                        }

                })


                setsCommonCancel.setOnClickListener(object:View.OnClickListener{
                    override fun onClick(v: View?) {
                        lifecycleScope.launch {
                            MaterialDialog.Builder(this@SysSettingActivity)
                                .content("恢复中...")
                                .contentGravity(GravityEnum.CENTER)
                                .progress(false, 150, true)
                                .showListener(OnShowListener {
                                        dialog: DialogInterface? ->
                                    run {
                                        var materialDialog = dialog as MaterialDialog
                                        while (materialDialog.currentProgress != materialDialog.maxProgress) {
                                            materialDialog.incrementProgress(10);
                                        }
                                        if(materialDialog.currentProgress ==materialDialog.maxProgress){

                                        }

                                    }

                                }).show()
                        }
                    }
                })


            }

            override fun onTabUnselected(index: Int) {
              //ignore
            }

            override fun onTabReselected(index: Int) {
                //ignore
            }

            override fun onDoubleTap(index: Int) {
                //ignore
            }
        })
        tabSegment.selectTab(0)
    }


}