package jx.cn.escort.ui.fragment




import android.content.Context
import android.content.SharedPreferences
import android.graphics.Color
import android.graphics.Typeface
import android.os.Bundle
import android.view.Gravity
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.appcompat.widget.AppCompatTextView
import androidx.fragment.app.Fragment
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.necer.calendar.Miui9Calendar
import com.xuexiang.xui.adapter.recyclerview.XGridLayoutManager
import com.xuexiang.xui.utils.WidgetUtils
import com.xuexiang.xui.widget.actionbar.TitleBar
import com.xuexiang.xui.widget.banner.recycler.BannerLayout
import com.xuexiang.xui.widget.dialog.materialdialog.DialogAction
import com.xuexiang.xui.widget.dialog.materialdialog.MaterialDialog
import com.xuexiang.xui.widget.textview.supertextview.SuperTextView
import jx.cn.escort.R
import jx.cn.escort.adapter.IndexAbilityRecycleAdapter
import jx.cn.escort.adapter.IndexRecycleAdapter
import jx.cn.escort.adapter.IndexStatRecycleAdapter
import jx.cn.escort.beans.AbilityData
import jx.cn.escort.beans.StatData
import jx.cn.escort.beans.TaskData
import jx.cn.escort.ui.activity.LoginActivity
import jx.cn.escort.ui.activity.SysSettingActivity
import jx.cn.escort.utils.ActivityUtils
import org.koin.core.component.KoinComponent
import org.koin.core.component.inject
import java.text.SimpleDateFormat
import java.util.*


class BaseNavFragment(name:Int,context: Context?):Fragment(),KoinComponent {
    private var name: Int? = null
    private var context: Context? = null
    private val mContext: Context   by  inject()
    init {
        this.name=name
        this.context=context

    }

    private val defaultSharedPreferences: SharedPreferences = androidx.preference.PreferenceManager.getDefaultSharedPreferences(mContext)

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        if(null!=name){
            if(name==R.layout.fragment_tasks){

               val view:View=inflater.inflate(name!!,container,false)
                val recycle=view.findViewById<RecyclerView>(R.id.tasks_recycle)
                var divideTitle=view.findViewById<TitleBar>(R.id.divide_title)
                var account=defaultSharedPreferences.getString("account","")
                var layoutManager=LinearLayoutManager(context)
                recycle.layoutManager=layoutManager
                var lines=mutableListOf<TaskData>()
                for(index in 0..<10 step 1){
                    lines.add(TaskData("线路${index}"))
                }
                var indexRecycleAdapter=IndexRecycleAdapter(context,lines)
                recycle.adapter=indexRecycleAdapter





                if(null!=account&&account.isNotBlank()&&account.matches(LoginActivity.toAccountRegex()[0])){
                    var title="1900-01-01"
                    try {
                        var date=Date()
                        val format = SimpleDateFormat("yyyy-MM-dd", Locale.CHINESE).format(date)
                        title= format.toString()

                    }catch (e:Exception){

                    }



                    divideTitle.setLeftText("线路日期: ")
                    divideTitle.setTitle(title)
                    divideTitle.setTitleColor(Color.BLACK)


                    divideTitle.setOnTitleClickListener(object : View.OnClickListener {
                        override fun onClick(p0: View?) {
                            val li = LayoutInflater.from(context)
                            val inflate = li.inflate(jx.cn.escort.R.layout.layout_task_calendar, null)
                            var miui9Calendar=inflate.findViewById<Miui9Calendar>(jx.cn.escort.R.id.miui9Calendar)
                            var textView=inflate.findViewById<AppCompatTextView>(jx.cn.escort.R.id.calendarTitle)
                            miui9Calendar.setOnCalendarChangedListener { baseCalendar, year, month, localDate, dateChangeBehavior ->
                                textView.text = localDate.toString()
                                textView.setTypeface(null, Typeface.BOLD)
                                textView.setGravity(Gravity.CENTER)

                            }

                            context?.let {
                            MaterialDialog.Builder(it)
                                    . customView(inflate, true)
                                    .title("选择日期")
                                    .positiveText("确定")
                                    .negativeText("取消")
                                .onPositive(object:MaterialDialog.SingleButtonCallback{
                                    override fun onClick(dialog: MaterialDialog, which: DialogAction) {
                                        divideTitle.setTitle(textView.text)
                                    }

                                })
                                .show()

                            }


                        }
                    })

                }
                return view
            }else   if(name==R.layout.fragment_index){
                val view:View=inflater.inflate(name!!,container,false)
                val recycle=view.findViewById<BannerLayout>(R.id.index_stat_recycle)
                val abilityRecycle=view.findViewById<RecyclerView>(R.id.index_ability_recycle)


                var statDatas=mutableListOf<StatData>()
                for(index in 0..<4 step 1){
                    when(index){
                        0->{
                            var data=StatData("当日线路","10")
                            statDatas.add(data)
                        }
                        1->{
                            var data= StatData("网点任务","120")
                            statDatas.add(data)
                        }
                        2->{
                            var data= StatData("周转箱(出)","30")
                            statDatas.add(data)
                        }
                        3->{
                           var data=StatData("周转箱(入)","150")
                            statDatas.add(data)
                        }

                    }
                }
                var indexStatRecycleAdapter=IndexStatRecycleAdapter(context,statDatas)
                recycle.setAdapter(indexStatRecycleAdapter)





                var abilityDatas=mutableListOf<AbilityData>()
                var   activity=AbilityData("任务交接",R.drawable.ic_action_task_hand,null)
                abilityDatas.add(activity)

                abilityRecycle.layoutManager= XGridLayoutManager(context,3 ,GridLayoutManager.HORIZONTAL,false)
                abilityRecycle.adapter = IndexAbilityRecycleAdapter(context,abilityDatas)


                return view
            }else   if(name==R.layout.fragment_mine){
                val view:View=inflater.inflate(name!!,container,false)
                val logoutView = view.findViewById<SuperTextView>(R.id.top_setting_logout_btn)
                val settingView = view.findViewById<SuperTextView>(R.id.top_setting_go_btn)
                logoutView?.setOnClickListener(object:View.OnClickListener{
                    override fun onClick(v: View?) {

                        context?.let {
                            MaterialDialog.Builder(it)
                                .title("登出")
                                .content("是否确认退出")
                                .positiveText("确定")
                                .negativeText("取消")
                                .onPositive(object:MaterialDialog.SingleButtonCallback{
                                    override fun onClick(dialog: MaterialDialog, which: DialogAction) {
                                        var editor=defaultSharedPreferences.edit()
                                        editor.clear()
                                        editor.apply()
                                        context?.let { ActivityUtils.startActivity(it,LoginActivity::class.java) }
                                    }

                                })
                                .show()
                        }




                    }
                })

                settingView?.setOnClickListener(object:View.OnClickListener{
                    override fun onClick(v: View?) {
                        context?.let { ActivityUtils.startActivity(it,SysSettingActivity::class.java) }
                    }
                })

                return view
            }else{
                return inflater.inflate(name!!,container,false)
            }

        }else{
            return super.onCreateView(inflater, container, savedInstanceState)
        }


    }


    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)


    }





}